<?php

//require_once '../library/phpmailer/SendMailer.php';
require_once 'mailtemplate.class.php';
require_once 'vrXMLDoc.php';

use Illuminate\Database\Capsule\Manager as DB;

class Common {

    private function generateToken($nonce, $timestamp) {
        $hash_str = "";
        $secret = SECRET;
        $private_key = PRIVATE_KEY;
        $hash_hmac_algo = HASH_HMAC_ALGO;
        $hash_str = "nonce=" . $nonce . "&timestamp=" . $timestamp . "|" . $secret;
        //echo "\nsecret : ".$secret."\nprivate_key : ".$private_key."\nhash_hmac_algo : ".$hash_hmac_algo."\n hash_str : ". $hash_str; 
        $sig = hash_hmac($hash_hmac_algo, $hash_str, $private_key);
        return $sig;
    }

    public function validateToken($data) {
        $nonce = '';
        $timestamp = '';
        $token = '';
//        foreach (getallheaders() as $key => $val) {
            if (isset($_SERVER['HTTP_NONCE']) && trim($_SERVER['HTTP_NONCE']) != "") {
                $nonce = $_SERVER['HTTP_NONCE'];
            }
            if (isset($_SERVER['HTTP_TIMESTAMP']) && trim($_SERVER['HTTP_TIMESTAMP']) != "") {
                $timestamp = $_SERVER['HTTP_TIMESTAMP'];
            }
            if (isset($_SERVER['HTTP_TOKEN']) && trim($_SERVER['HTTP_TOKEN']) != "") {
                $token = $_SERVER['HTTP_TOKEN'];
            }
//        }

        $response = [];
        if (empty($token)) {
            $response['status'] = 400;
            $response['message'] = 'Token can not be blank';
            return $response;
        }
        if (empty($nonce)) {
            $response['status'] = 400;
            $response['message'] = 'Nonce value can not be blank';
            return $response;
        }
        if (empty($timestamp)) {
            $response['status'] = 400;
            $response['message'] = 'Timestamp value can nt be blank.';
            return $response;
        }
        if (!empty($nonce) && !empty($timestamp)) {
            $sig = $this->generateToken($nonce, $timestamp);
            if ($sig === $token) {
                $response["status"] = 200;
                $response[message] = 'Token is valid';
            } else {
                $response["status"] = 400;
                $response[message] = 'Token is invalid';
            }
        }
        return $response;
    }

    //Check http request content type
    public function checkContentType($request_method) {
        $response = ["status" => 400, message => 'Invalid Content Type'];
        if ($_SERVER['REQUEST_METHOD'] == $request_method) {
            if ($_SERVER['REQUEST_METHOD'] != 'GET' && $_SERVER['REQUEST_METHOD'] != 'DELETE') {
                if (isset($_SERVER["CONTENT_TYPE"]) && $_SERVER["CONTENT_TYPE"] != "") {
                    $content_type = explode(' ', trim($_SERVER["CONTENT_TYPE"]));
                    if ($content_type[0] == 'application/x-www-form-urlencoded' || $content_type[0] == 'application/x-www-form-urlencoded;') {
                        $response = ["status" => 200, message => 'Valid Content Type'];
                    }
                }
            } else {
                $response = ["status" => 200, message => 'Valid Content Type'];
            }
        } else {
            $response = ["status" => 405, message => 'Method Not Allowed'];
        }
        return $response;
    }

    //token validation
    public function apiRequestCheck($post, $flag = true) {
        if ((!empty($post) && $flag) || !$flag) {
            $post = array_map('trim', $post);
            $token = $this->validateToken($post);
            if ($token['status'] == 200) {
                $response['status'] = '200';
            } else {
                $response['status'] = $token['status'];
                $response ['message'] = $token['message'];
            }
        } else {
            $response['status'] = 400;
            $response ['message'] = "Please add required fields.";
        }
        return $response;
    }

    //Check required field validation check
    public function fieldValidation($post, $arraycheck = array()) {
        $post = array_map('trim', $post);
        foreach ($arraycheck as $key => $value) {
            $rule = explode("|", $value);
            //Required field validation
            if (in_array('required', $rule)) {
                $res = $this->emptyCheck($post[$key], $key);
                if ($res['status'] !== 200) {
                    return $res;
                }
            }
            //Email validation
            if (in_array('email', $rule)) {
                if (!filter_var($post[$key], FILTER_VALIDATE_EMAIL)) {
                    return ["status" => 400, message => $key . ' is invalid email.'];
                }
            }
            //Integer validation
            if (in_array('integer', $rule)) {
                if (!filter_var($post[$key], FILTER_VALIDATE_INT)) {
                    return ["status" => 400, message => $key . ' should be integer.'];
                }
            }
        }
        return array("status" => 200, message => "");
    }

    private function emptyCheck($val, $key) {
        if ($val == "" || $val == null) {
            return ["status" => 400, message => $key . ' is required.'];
        }
        return ["status" => 200];
    }

    private function Trimpost($post) {
        $post = array_map('trim', $post);
        foreach ($post as $key => $value) {
            $post[$key] = urldecode($value);
        }
        return $post;
    }
    
    //Generate random unique string
    public static function generateRandomToken() {
        $chars = "abcdefghijkmnopqrstuvwxyz023456789";
        srand((double) microtime() * 1000000);
        $i = 0;
        $pass = '';
        while ($i <= 60) {
            $num = rand() % 33;
            $tmp = substr($chars, $num, 1);
            $pass = $pass . $tmp;
            $i++;
        }
        return $pass;
    }

    /*
     * Send mail via phpmailer
     */

    public static function send_mail($to, $from, $from_name, $subject, $body, $bcc = NULL) {
        $transport = (new Swift_SmtpTransport(SMTP_HOST, SMTP_POST, SMTP_ENCRYPTION))
                ->setUsername(SMTP_EMAIL)
                ->setPassword(SMTP_PASSWORD);

        $mailer = new Swift_Mailer($transport);

        // Create a message
        $obj = (new Swift_Message($subject))
                ->setContentType("text/html")
                ->setFrom([$from => $from_name])
                ->setTo([$to => '']);
        if($bcc != NULL){
            $obj->setBcc($bcc);
        }
        $message = $obj->setBody($body);

        // Send the message
        $mailer->send($message);
        return true;


//        $mailer = new SendMailer();
//        return $mailer->sendmail($to, $from, $from_name, $subject, $body);
    }

    /*
     * Email templates
     */

    public static function mailTemplate($template, $params) {
        if ($template == 'forgotpassword') {
            return Mailtemplate::forgotpasswordMail($params);
        } else if ($template == 'custom_quote') {
            return Mailtemplate::customQuoteMail($params);
        } else if ($template == 'vci_selection_help') {
            return Mailtemplate::vciSelectionHelpMail($params);
        } else if ($template == 'vci_selection_confirmation') {
            return Mailtemplate::vciSelectionConfirmation($params);
        } else if ($template == 'ask_question') {
            return Mailtemplate::askQuestion($params);
        } else if ($template == 'orderreceipt') {
            return Mailtemplate::orderReceipt($params);
        } else {
            
        }
    }

    /*
     * Get the time in form of second, minute, day month etc
     */

    public static function timeElapsedString($datetime, $full = false) {
        $now = new \DateTime;
        $ago = new \DateTime($datetime);
        $diff = $now->diff($ago);

        $diff->w = floor($diff->d / 7);
        $diff->d -= $diff->w * 7;

        $string = array(
            'y' => 'year',
            'm' => 'month',
            'w' => 'week',
            'd' => 'day',
            'h' => 'hour',
            'i' => 'minute',
            's' => 'second',
        );
        foreach ($string as $k => &$v) {
            if ($diff->$k) {
                $v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? 's' : '');
            } else {
                unset($string[$k]);
            }
        }

        if (!$full)
            $string = array_slice($string, 0, 1);
        return $string ? implode(', ', $string) . ' ago' : 'just now';
    }

    /*
     * Push notification types
     */

    public static function notificationType($tNotificationType) {
        $typeArr = [
            'product_purchase' => 1,
        ];

        return $typeArr[$tNotificationType];
    }

    /*
     * Send notification 
     */

    public static function sendNotification($data) {

        $iNotificationId = DB::table('notifications')->insertGetId(
                [
                    'iSenderUserId' => $data['iSenderUserId'],
                    'iReceiverUserId' => $data['iReceiverUserId'],
                    'tNotificationType' => $data['tNotificationType'],
                    'txParameters' => $data['txParameters'],
                    'vTitle' => $data['vTitle'],
                    'vText' => $data['vText'],
                    'updated_at' => date('Y-m-d H:i:s'),
                    'created_at' => date('Y-m-d H:i:s'),
                ]
        );

        if ($iNotificationId > 0) {
            $model = Notification::where(['iNotificationId' => $iNotificationId])->first();
            if (!empty($model)) {
                return self::performNotification($model);
            } else {
                return false;
            }
        }

        return false;
    }

    private static function performNotification($model) {
        if (!empty($model->receiver_user) && !empty($model->receiver_user->device) && strlen($model->receiver_user->device->txDeviceToken) >= 64) {
            //Unread notification count
            $badgeCount = DB::table('notifications')->where(['iReceiverUserId' => $model->receiver_user->clID, 'tRead' => 0])->count();
            if ($model->receiver_user->device->tDeviceOs == 1) {
                //ANDROID
                //FCM Message array
                $message = [
                    //'title' => $model->vText,
                    'message' => $model->vText,
                    'tNotificationType' => $model->tNotificationType,
                    'txParameters' => $model->txParameters,
                    'badge' => $badgeCount,
                    'vibrate' => 1,
                    'sound' => 1,
                ];

                return self::notificationAndroid([$model->receiver_user->device->txDeviceToken], $message);
            } else {
                //IOS
                if (strlen($model->receiver_user->device->txDeviceToken) == 64) {
                    $payloadArr = [
                        'aps' => [
                            'alert' => $model->vText,
                            'sound' => 'default',
                            'badge' => $badgeCount,
                            'tNotificationType' => $model->tNotificationType,
                        ],
                        'txParameters' => json_decode($model->txParameters, true),
                    ];
                    return self::notificationIphone($model->receiver_user->device->txDeviceToken, $payloadArr, $model->receiver_user->tRole);
                }
            }
        }
        return false;
    }

    /**
     * Sent push notification code for Iphone
     * @param  string $deviceToken [description]
     * @param  array  $payloadArr  [description]
     * @return boolean              
     */
    public static function notificationIphone($deviceToken = NULL, $payloadArr = [], $tRole = 0) {
        /* $payload = [];
          $payload['aps'] = $payloadArr;
          $payload = json_encode($payload);

          if(config('app.ios_live_env')){
          //Live
          $apnsHost = 'gateway.push.apple.com';
          }else{
          //Sandbox
          $apnsHost = 'gateway.sandbox.push.apple.com';
          }

          $apnsPort = 2195;

          if($tRole == 1){
          //User (Customer)
          $apnsCert = storage_path().'/'.config('app.ios_user_pem_file');
          }else if($tRole == 2){
          //Host
          $apnsCert = storage_path().'/'.config('app.ios_host_pem_file');
          }else{
          return 0;
          }
          // Put your private key's passphrase here:
          $passphrase = '';

          $streamContext = @stream_context_create();
          @stream_context_set_option($streamContext, 'ssl', 'local_cert', $apnsCert);
          //@stream_context_set_option($streamContext, 'ssl', 'passphrase', $passphrase);

          $apns = @stream_socket_client('ssl://' . $apnsHost . ':' . $apnsPort, $error, $errorString, 2, STREAM_CLIENT_CONNECT, $streamContext);
          //$apns = @stream_socket_client('tls://' . $apnsHost . ':' . $apnsPort, $error, $errorString, 2, STREAM_CLIENT_CONNECT, $streamContext);
          $apnsMessage = chr(0) . chr(0) . chr(32) . pack('H*', str_replace(' ', '', $deviceToken)) . chr(0) . chr(strlen($payload)) . $payload;
          $result = @fwrite($apns, $apnsMessage);

          if (!$apns) {
          return false;
          }
          if (!$result) {
          //failure
          } else {
          //success
          }
          fclose($apns); */
        return true;
    }

    /*
     * Send Android notification
     */

    public static function notificationAndroid($registatoin_ids, $messageArr = []) {
        $url = ANDROID_FCM_URL;

        $fields = array(
//            "notification" => [
//                "title" => config('app.name'),
//                "body" => $messageArr['message'],
//            ],
            'registration_ids' => $registatoin_ids,
            'data' => $messageArr
        );

        $headers = array(
            'Authorization: key=' . FCM_KEY,
            'Content-Type: application/json'
        );
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
        $result = curl_exec($ch);
//        print_r($result);exit;
        if ($result === FALSE) {
            die('Curl failed: ' . curl_error($ch));
        }
        curl_close($ch);
        return $result;
    }

    public static function getUserIP() {
        if (array_key_exists('HTTP_X_FORWARDED_FOR', $_SERVER) && !empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            if (strpos($_SERVER['HTTP_X_FORWARDED_FOR'], ',') > 0) {
                $addr = explode(",", $_SERVER['HTTP_X_FORWARDED_FOR']);
                return trim($addr[0]);
            } else {
                return $_SERVER['HTTP_X_FORWARDED_FOR'];
            }
        } else {
            return $_SERVER['REMOTE_ADDR'];
        }
    }

    public static function getAdminSettings() {
        $setting = DB::table('admin')->selectRaw("adminEmail,adminEmailConfirm,adminProdsPerPage,adminStoreURL,adminStoreURLSSL,adminHandling,adminHandlingPercent,adminPacking,adminDelCC,adminUSZones,adminStockManage,adminShipping,adminIntShipping,adminCanPostUser,adminCanPostLogin,adminCanPostPass,adminZipCode,adminUnits,adminUSPSUser,smartPostHub,adminUSPSpw,adminUPSUser,adminUPSpw,adminUPSAccess,adminUPSAccount,adminUPSNegotiated,FedexAccountNo,FedexMeter,FedexUserKey,FedexUserPwd,DHLSiteID,DHLSitePW,DHLAccountNo,adminlanguages,adminlangsettings,currRate1,currSymbol1,currRate2,currSymbol2,currRate3,currSymbol3,currConvUser,currConvPw,currLastUpdate,adminSecret,countryLCID,countryCurrency,countryNumCurrency,countryName,countryCode,countryID,countryTax,currSymbolText,currDecimalSep,currThousandsSep,currPostAmount,currDecimals,currSymbolHTML,cardinalProcessor,cardinalMerchant,cardinalPwd,catalogRoot,adminAltRates,prodFilter,prodFilterText,prodFilterText2,prodFilterText3,prodFilterOrder,sortOrder,sortOptions,storelang,reCAPTCHAsitekey,reCAPTCHAsecret,reCAPTCHAuseon,onvacation,mailchimpAPIKey,mailchimpList")
                ->leftjoin('countries', 'admin.adminCountry', '=', 'countries.countryID')
                ->where('adminID', 1)
                ->first();
        return $setting;
    }

    /*
     * curl call function for fedex
     */

    public static function callcurlfunction($cfurl, $cfxml, &$cfres, $cfcert, &$cferrmsg, $settimeouts) {

//        global $curlproxy, $pathtocurl, $xmlfnheaders, $debugxmlemails, $emailAddr, $htmlemails, $http_status, $xmlfnuser, $xmlfnpassword;

        $curlproxy = '';
        $pathtocurl = '/usr/bin/curl';
        $xmlfnheaders = '';
        $debugxmlemails = '';
        $emailAddr = CLIENT_EMAIL;
        $htmlemails = true;
        $http_status = '';
        $xmlfnuser = '';
        $xmlfnpassword = '';

        $cfsuccess = TRUE;
        if (@$pathtocurl != '') {
            exec($pathtocurl . ($cfcert != '' ? ' -E \'' . $cfcert . '\'' : '') . ' --data-binary ' . escapeshellarg($cfxml) . ' ' . $cfurl, $cfres, $retvar);
            $cfres = implode("\n", $cfres);
            if ($cfres == '') {
                $cferrmsg = 'No response from path: ' . $pathtocurl;
                $cfsuccess = FALSE;
            }
        } else {
            if (!function_exists('curl_init') || !$ch = curl_init()) {
                $cferrmsg = 'cURL package not installed in PHP. Set \$pathtocurl parameter.';
                $cfsuccess = FALSE;
            } else {
                curl_setopt($ch, CURLOPT_URL, $cfurl);
                if ($xmlfnuser != '' && $xmlfnpassword != '') {
                    curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
                    curl_setopt($ch, CURLOPT_USERPWD, $xmlfnuser . ':' . $xmlfnpassword);
                }
                if (is_array($xmlfnheaders))
                    curl_setopt($ch, CURLOPT_HTTPHEADER, $xmlfnheaders);
                if ($cfcert != '') {
                    if (substr($cfcert, 0, 6) == 'CAINFO') {
                        $cfcert = substr($cfcert, 6);
                        curl_setopt($ch, CURLOPT_CAINFO, $cfcert);
                    } else
                        curl_setopt($ch, CURLOPT_SSLCERT, $cfcert);
                }
                if ($cfxml != '')
                    curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_HEADER, 0);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
                if ($cfxml != '')
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $cfxml);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                if ($settimeouts) {
                    if ($settimeouts > 10)
                        curl_setopt($ch, CURLOPT_TIMEOUT, $settimeouts);
                    else
                        curl_setopt($ch, CURLOPT_TIMEOUT, 120);
                }
                if (@$curlproxy != '')
                    curl_setopt($ch, CURLOPT_PROXY, $curlproxy);
                $cfres = curl_exec($ch);

                $http_status = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                if (curl_error($ch) != '') {
                    if ($cfcert != '' && !is_file($cfcert)) {
                        $cferrmsg = 'Certificate file not found: ' . $cfcert;
                    } else
                        $cferrmsg = curl_error($ch);
                    $cfsuccess = FALSE;
                } else
                    curl_close($ch);
            }
        }
        if (@$debugxmlemails) {
            dosendemail($emailAddr, $emailAddr, '', 'PHP XML Function Debug', (@$GLOBALS['htmlemails'] ? str_replace('<', '&lt;', $cfxml) : $cfxml) . $GLOBALS['emlNl'] . $GLOBALS['emlNl'] . (@$GLOBALS['htmlemails'] ? str_replace('<', '&lt;', $cfres) : $cfres) . $GLOBALS['emlNl'] . $GLOBALS['emlNl'] . $cfsuccess);
        }
        $xmlfnheaders = $xmlfnuser = $xmlfnpassword = '';
        return($cfsuccess);
    }

    public static function parsefedexXMLoutput($sXML, $international, $errormsg, $errorcode, &$intShipping, $_param) {
        $xxDay = $_param['xxDay'];
        $xxDays = $_param['xxDays'];
        $uselistshippingrates = $_param['uselistshippingrates'];
        $commercialloc_ = $_param['commercialloc_'];
        $origCountryCode = $_param['origCountryCode'];
        $shipCountryCode = $_param['shipCountryCode'];
        $nofedexinternationalground = $_param['nofedexinternationalground'];
        $fedextestmode = $_param['fedextestmode'];
        $fedexnamespace = $_param['fedexnamespace'];
        $discountshippingfedex = $_param['discountshippingfedex'];

        $noError = TRUE;
        $errormsg = '';
        $discntsApp = '';
        $l = strpos($sXML, ']>');
        if ($l > 0)
            $sXML = substr($sXML, $l + 2);
        $l = 0;
        $fns = $fedexnamespace;

        $xmlDoc = new \api\common\vrXMLDoc($sXML);

        $nodeList = $xmlDoc->nodeList->childNodes[0];

        for ($i = 0; $i < $nodeList->length; $i++) {
            if (strtolower($nodeList->nodeName[$i]) == 'soapenv:body' || strtolower($nodeList->nodeName[$i]) == 'soap-env:body') {
                $nodeList = $nodeList->childNodes[$i];
            }
        }
        for ($i = 0; $i < $nodeList->length; $i++) {
            if ($nodeList->nodeName[$i] == $fns . 'RateReply') {
                $nodeList = $nodeList->childNodes[$i];
            }
        }

        for ($i = 0; $i < $nodeList->length; $i++) {
            if ($nodeList->nodeName[$i] == $fns . 'HighestSeverity') {
                if ($nodeList->nodeValue[$i] == 'ERROR') {
                    $noError = FALSE;
                    $e = $nodeList->childNodes[$i];
                    for ($j = 0; $j < $e->length; $j++) {
                        if ($e->nodeName[$j] == $fns . 'Message') {
                            $errormsg = $e->nodeValue[$j];
                        } elseif ($e->nodeName[$j] == $fns . 'Code') {
                            $errorcode = $e->nodeValue[$j];
                        }
                    }
                }
            } elseif ($nodeList->nodeName[$i] == $fns . 'Notifications') {
                $iserror = FALSE;
                $themessage = '';
                $thecode = '';
                $e = $nodeList->childNodes[$i];
                for ($j = 0; $j < $e->length; $j++) {
                    if ($e->nodeName[$j] == $fns . 'Message') {
                        $themessage = $e->nodeValue[$j];
                    } elseif ($e->nodeName[$j] == $fns . 'Code') {
                        $thecode = $e->nodeValue[$j];
                    } elseif ($e->nodeName[$j] == $fns . 'Severity') {
                        $iserror = $e->nodeValue[$j] == 'ERROR';
                    }
                }
                if ($iserror) {
                    $errormsg = $themessage;
                    $errorcode = $thecode;
                }
            } elseif ($nodeList->nodeName[$i] == $fns . 'RateReplyDetails') {
                $thisratetype = '';
                $wantthismethod = FALSE;
                $e = $nodeList->childNodes[$i];
                $entryweight = $e->getValueByTagName('BilledWeight');
                for ($j = 0; $j < $e->length; $j++) {
                    if ($e->nodeName[$j] == $fns . 'ServiceType') {
                        $thisratetype = '';
                        $theservicename = str_replace('_', '', $e->nodeValue[$j]);

                        $wantthismethod = Common::checkUPSShippingMeth($theservicename, $discntsApp, $showAs);
                        // if($e->nodeValue[$j]=='FEDEXGROUND' && $shipCountryCode!='CA' && $shipCountryCode!='PR' && !$commercialloc_ && $entryweight<=70.0) $wantthismethod=FALSE;
                        if ($origCountryCode != $shipCountryCode) {
                            // if(strpos($showAs,'FedEx Ground')!==FALSE && @$nofedexinternationalground==TRUE) $wantthismethod=FALSE;
                            $showAs = str_replace('FedEx Ground', 'FedEx International Ground', $showAs);
                        }

                        if ($wantthismethod) {
                            $intShipping[$l][0] = $showAs;
                            $intShipping[$l][4] = $discntsApp;
                        }
                    } elseif ($e->nodeName[$j] == $fns . 'RatedShipmentDetails' && $thisratetype != 'PAYOR_ACCOUNT_SHIPMENT') {
                        $t = $e->childNodes[$j];
                        for ($k = 0; $k < $t->length; $k++) {
                            if ($t->nodeName[$k] == $fns . 'ShipmentRateDetail') {
                                $intShipping[$l][2] = 0;
                                $u = $t->childNodes[$k];
                                for ($kk = 0; $kk < $u->length; $kk++) {
                                    if ($u->nodeName[$kk] == $fns . 'RateType') {
                                        $thisratetype = $u->nodeValue[$kk];
                                    } elseif ($u->nodeName[$kk] == $fns . 'TotalNetCharge') {
                                        $intShipping[$l][2]+=(double) $u->childNodes[$kk]->getValueByTagName($fns . 'Amount');
                                    } elseif ($u->nodeName[$kk] == $fns . 'TotalFreightDiscounts') {
                                        //if (@$uselistshippingrates == TRUE){
                                        $intShipping[$l][2]+=(double) $u->childNodes[$kk]->getValueByTagName($fns . 'Amount');
                                        //}
                                    }
                                }
                            }
                        }
                    } elseif ($e->nodeName[$j] == $fns . 'DeliveryTimestamp' && !@$GLOBALS['noshipdateestimate']) {
                        $today = getdate();
                        $daytoday = $today['yday'];
                        if (($ttimeval = strtotime($e->nodeValue[$j])) < 0) {
                            $intShipping[$l][1] = $e->nodeValue[$j] . $intShipping[$l][1];
                        } else {
                            $deldate = getdate($ttimeval);
                            $daydeliv = $deldate['yday'];
                            if ($daydeliv < $daytoday)
                                $daydeliv+=365;
                            for ($index = 0; $index <= ($daydeliv - $daytoday); $index++) {
                                $ckwekday = getdate(time() + 60 * 60 * 24 * $index);
                                if ($ckwekday['wday'] == 0 || $ckwekday['wday'] == 6)
                                    $daydeliv+=1;
                            }
                            $intShipping[$l][1] = ($daydeliv - $daytoday) . ' ' . ($daydeliv - $daytoday < 2 ? $xxDay : $xxDays) . $intShipping[$l][1];
                        }
                    }elseif ($e->nodeName[$j] == $fns . 'TransitTime' && !@$GLOBALS['noshipdateestimate']) {
                        if ($e->nodeValue[$j] == 'ONE_DAY')
                            $intShipping[$l][1] = '1 ' . $xxDay;
                        if ($e->nodeValue[$j] == 'TWO_DAYS')
                            $intShipping[$l][1] = '2 ' . $xxDays;
                        if ($e->nodeValue[$j] == 'THREE_DAYS')
                            $intShipping[$l][1] = '3 ' . $xxDays;
                        if ($e->nodeValue[$j] == 'FOUR_DAYS')
                            $intShipping[$l][1] = '4 ' . $xxDays;
                        if ($e->nodeValue[$j] == 'FIVE_DAYS')
                            $intShipping[$l][1] = '5 ' . $xxDays;
                        if ($e->nodeValue[$j] == 'SIX_DAYS')
                            $intShipping[$l][1] = '6 ' . $xxDays;
                        if ($e->nodeValue[$j] == 'SEVEN_DAYS')
                            $intShipping[$l][1] = '7 ' . $xxDays;
                    }
                }

                if ($wantthismethod) {
                    if (@$discountshippingfedex != '') {
                        $intShipping[$l][2] = round($intShipping[$l][2] * (1 + $discountshippingfedex / 100.0), 2);
                    }
                    $intShipping[$l][3] = TRUE;
                    $l++;
                } else {
                    $intShipping[$l][1] = '';
                }
            }
        };

        return $noError;
    }

    public static function checkUPSShippingMeth($method, $discountsApply, &$showAs) {
        global $numuspsmeths, $uspsmethods;

        $uspsmethods = DB::table("uspsmethods")
                        ->selectRaw("uspsMethod,uspsFSA,uspsShowAs,uspsLocal")
                        ->whereRaw("uspsID > 300 AND uspsID < 400 AND uspsUseMethod = 1")
                        ->get()->toArray();
        $numuspsmeths = count($uspsmethods);

        $discountsApply = 0;
        for ($index = 0; $index < $numuspsmeths; $index++) {

            if ($method == $uspsmethods[$index]->uspsMethod) {
                $discountsApply = $uspsmethods[$index]->uspsFSA;
                $showAs = $uspsmethods[$index]->uspsShowAs;
                return(TRUE);
            }
        }
        return(FALSE);
    }

    public static function sortshippingarray($intShipping, $maxshipoptions) {
        $maxallocateditem = 0;
        for ($ssaindex = 0; $ssaindex < $maxshipoptions; $ssaindex++) {
            if ($intShipping[$ssaindex][3])
                $maxallocateditem = $ssaindex;
        }

        for ($ssaindex = 0; $ssaindex <= $maxallocateditem; $ssaindex++) {
            $intShipping[$ssaindex][2] = (double) $intShipping[$ssaindex][2];
            if ($intShipping[$ssaindex][3]) {
                for ($ssaindex2 = $ssaindex + 1; $ssaindex2 <= $maxallocateditem; $ssaindex2++) {
                    if ($intShipping[$ssaindex][3] && $intShipping[$ssaindex2][3] && ($intShipping[$ssaindex][0] == $intShipping[$ssaindex2][0])) {
                        if ($intShipping[$ssaindex][2] < $intShipping[$ssaindex2][2]) {
                            if ($intShipping[$ssaindex2][4] == 0)
                                $intShipping[$ssaindex2][3] = 0;
                        }else {
                            if ($intShipping[$ssaindex][4] == 0)
                                $intShipping[$ssaindex][3] = 0;
                        }
                    }
                }
            }
        }

        $maxshipoptions = $maxallocateditem + 1;
        for ($ssaindex2 = 0; $ssaindex2 < $maxshipoptions; $ssaindex2++) {
            for ($ssaindex = 1; $ssaindex < $maxshipoptions; $ssaindex++) {
                if (!$intShipping[$ssaindex - 1][3] || ($intShipping[$ssaindex][3] && ((double) $intShipping[$ssaindex][2] < (double) $intShipping[$ssaindex - 1][2]))) {
                    $tt = $intShipping[$ssaindex];
                    $intShipping[$ssaindex] = $intShipping[$ssaindex - 1];
                    $intShipping[$ssaindex - 1] = $tt;
                }
            }
        }
        return ['maxshipoptions' => $maxshipoptions, 'intShipping' => $intShipping];
    }

    public static function braintreeObject() {
        $gateway = new \Braintree\Gateway([
            'environment' => BT_ENVIRONMENT,
            'merchantId' => BT_MERCHANT_ID,
            'publicKey' => BT_PUBLIC_KEY,
            'privateKey' => BT_PRIVATE_KEY
        ]);

        return $gateway;
    }
    
    public static function ordinal($number) {
        $ends = array('th','st','nd','rd','th','th','th','th','th','th');
        if ((($number % 100) >= 11) && (($number%100) <= 13))
            return $number. 'th';
        else
            return $number. $ends[$number % 10];
    }
}
