<?php
error_reporting(E_ERROR | E_PARSE);
//error_reporting(E_ALL | E_PARSE);
ini_set('display_errors', 1);

//Default Timezone
date_default_timezone_set('US/Eastern');

include('parameters.php');

include __DIR__ . '/../vendor/autoload.php';
require_once('common.class.php');
require_once '../library/php-activerecord/ActiveRecord.php';
require_once '../library/braintree-php/lib/Braintree.php';

use Illuminate\Database\Capsule\Manager as Capsule;

$capsule = new Capsule;
$capsule->addConnection(["driver" => "mysql","host" => DB_HOST,"database" => DB_NAME,"username" => DB_USER,"password" => DB_PASSWORD]);
//Make this Capsule instance available globally.
$capsule->setAsGlobal();
// Setup the Eloquent ORM.
$capsule->bootEloquent();


global $api_response, $api_message_data, $authuser;
$api_response = [];
$api_message_data = [];
include('api-message.php');
/*
 * Active records configuration
 */
ActiveRecord\Config::initialize(function($cfg) {
    $cfg->set_model_directory('models');
});

/*
 * Api response generate
 */

function _response($res) {
    global $api_response, $api_message_data;
    if (empty($res)) {
        $res['staus'] = 400;
        $res['message'] = 'Invalid request';
    }

    http_response_code(statusArr($res['status']));
    unset($res['status']);
    $d_msg = $api_message_data[$res['message']];
    $res['message'] = ($d_msg != NULL) ? $d_msg : $res['message'];
    $api_response = $res;
}

function statusArr($flag) {
    if (is_bool($flag)) {
        if ($flag) {
            return 200;
        } else {
            return 400;
        }
    } else {
        return $flag;
    }
}

$main_script_url = $_SERVER['SCRIPT_NAME'];
$api_root_url = str_replace('index.php', '', $main_script_url);

$_action_uri = explode($api_root_url, $_SERVER['REDIRECT_URL']);
$_query_params_uri = explode("/",end($_action_uri));

$_params = NULL;
if(count($_query_params_uri) == 2){
    $_action = $_query_params_uri[0];
    $_params = end($_query_params_uri);
}else{
    $_action = end($_action_uri);
}
?>