<?php

/**
 * @SWG\Post(path="/change_password",
 *     summary="Change user password",
 *     consumes={"application/x-www-form-urlencoded"},
 *     @SWG\Parameter(
 *         description="Old password",
 *         in="formData",
 *         name="vOldPassword",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="",
 *     ),
 *     @SWG\Parameter(
 *         description="New password",
 *         in="formData",
 *         name="vNewPassword",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="",
 *     ),
 *     @SWG\Parameter(
 *         name="clID",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Change password response",
 *         @SWG\Schema(
 *                ref="#/definitions/ChangePasswordFinalResponse"
 *              ), 
 *         examples={
 *                   "application/json": {
 *                       "message": "Password changed successfully."
 *                   }
 *           },
 *     ),
 *   @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ),     
 *         examples={
 *                   "application/json": {
 *                           "message": "Old password is wrong."
 *                       }
 *             },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = $_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post);
    if ($response['status'] == 200) {
        //User Authentication
        $response = Authentication::auth_user();
        if ($response['status'] == 200) {
            //Validation rules
            $requiredFields = [
                'vOldPassword' => 'required',
                'vNewPassword' => 'required',
            ];
            $response = $obj->fieldValidation($post, $requiredFields);
            if ($response['status'] == 200) {
                $model = new Customerlogin();
                $response = $model->change_password($post);
            }
        }
    }
}
_response($response);
