<?php

/**
 * @SWG\Post(path="/checkout",
 *     summary="Checkout",
 *     consumes={"application/x-www-form-urlencoded"},
 *     @SWG\Parameter(
 *         description="ordCompany",
 *         in="formData",
 *         name="ordCompany",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="test",
 *     ),
 *     @SWG\Parameter(
 *         description="Order country",
 *         in="formData",
 *         name="ordCountry",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="United States of America",
 *     ),
 *     @SWG\Parameter(
 *         description="Order Name",
 *         in="formData",
 *         name="ordName",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Test user",
 *     ),
 *     @SWG\Parameter(
 *         description="Order address",
 *         in="formData",
 *         name="ordAddress",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Washington dc",
 *     ),
 *     @SWG\Parameter(
 *         description="Order city",
 *         in="formData",
 *         name="ordCity",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Washington dc",
 *     ),
 *     @SWG\Parameter(
 *         description="Order state",
 *         in="formData",
 *         name="ordState",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Washington dc",
 *     ), 
 *     @SWG\Parameter(
 *         description="Order zip",
 *         in="formData",
 *         name="ordZip",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="90001",
 *     ),
 *     @SWG\Parameter(
 *         description="Order phone",
 *         in="formData",
 *         name="ordPhone",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="8545256956",
 *     ),
 *     @SWG\Parameter(
 *         description="Order email",
 *         in="formData",
 *         name="ordEmail",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="abc@gmail.com",
 *     ),
 *     @SWG\Parameter(
 *         description="Order transit id",
 *         in="formData",
 *         name="ordTransID",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="GJGJGJK",
 *     ),
 *     @SWG\Parameter(
 *         description="Order pay provider (1 = Card , 4 = Email)",
 *         in="formData",
 *         name="ordPayProvider",
 *         required=true,
 *         type="integer",
 *         format="integer",
 *         default="1",
 *     ),
 *     @SWG\Parameter(
 *         description="Order ship carrier (1 = Yes , 0 = No)",
 *         in="formData",
 *         name="ordShipCarrier",
 *         required=false,
 *         type="integer",
 *         format="integer",
 *         default="1",
 *     ),
 *     @SWG\Parameter(
 *         description="Ship to different address (1 = Yes , 0 = No)",
 *         in="formData",
 *         name="shipToDifferentAddress",
 *         required=true,
 *         type="integer",
 *         format="integer",
 *         default="1",
 *     ),
 *     @SWG\Parameter(
 *         description="Ship to company name",
 *         in="formData",
 *         name="ordShipCompanyName",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="company name",
 *     ),
 *     @SWG\Parameter(
 *         description="Ship name",
 *         in="formData",
 *         name="ordShipName",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="ship name",
 *     ),
 *     @SWG\Parameter(
 *         description="Ship address",
 *         in="formData",
 *         name="ordShipAddress",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="ship address",
 *     ),
 *     @SWG\Parameter(
 *         description="Ship city",
 *         in="formData",
 *         name="ordShipCity",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="ship city",
 *     ),
 *     @SWG\Parameter(
 *         description="Ship country",
 *         in="formData",
 *         name="ordShipCountry",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="ship country",
 *     ),
 *     @SWG\Parameter(
 *         description="Ship state",
 *         in="formData",
 *         name="ordShipState",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="ship state",
 *     ),
 *     @SWG\Parameter(
 *         description="Ship zip",
 *         in="formData",
 *         name="ordShipZip",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="ship zip",
 *     ),
 *     @SWG\Parameter(
 *         description="Ship phone",
 *         in="formData",
 *         name="ordShipPhone",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="ship phone",
 *     ),
 *     @SWG\Parameter(
 *         description="Ship billing zip",
 *         in="formData",
 *         name="ordShipBillingZip",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="ship billing zip",
 *     ),
 *     @SWG\Parameter(
 *         description="Fedex shipping charge according to options selection",
 *         in="formData",
 *         name="ordShipping",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="",
 *     ),
 *     @SWG\Parameter(
 *         description="Fedex shipping type text",
 *         in="formData",
 *         name="ordShipType",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="FedEx Ground&reg;",
 *     ),
 *     @SWG\Parameter(
 *         name="clID",
 *         in="header",
 *         required=false,
 *         type="string",
 *         default="586",
 *     ),
 *     @SWG\Parameter(
 *         description="Is guest (0 = Login user, 1 = Guest)",
 *         name="tIsGuest",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default="0",
 *     ),
 *     @SWG\Parameter(
 *         name="cartSessionID",
 *         in="header",
 *         required=false,
 *         type="string",
 *         default="",
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Add to cart response",
 *         @SWG\Schema(
 *                ref="#/definitions/CheckoutFinalResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                       "message": "Operation success"
 *                   }
 *          },
 *     ),
 *    @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ), 
 *         examples={
 *                   "application/json": {
 *                         "message": "Operation failed",
 *                         "data": {}
 *                   }
 *         },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = $_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post);
    if ($response['status'] == 200) {
        
        
        if(isset($_SERVER['HTTP_TISGUEST']) && trim($_SERVER['HTTP_TISGUEST']) != ""){
            $tIsGuest = trim($_SERVER['HTTP_TISGUEST']);
            if($tIsGuest == 0 || $tIsGuest == ""){
                //User Authentication
                $response = Authentication::auth_user();
                if ($response['status'] != 200) {
                    _response($response);
                    return;
                }
            }
            //Validation rules
            $requiredFields = [
                'ordCompany'=> 'required',
                'ordCountry' => 'required',
                'ordName' => 'required',
                'ordAddress' => 'required',
                'ordCity' => 'required',
                'ordState' => 'required',
                'ordZip' => 'required',
                'ordPhone' => 'required',
                'ordEmail' => 'required',
                //'ordTransID' => 'required', //Payment transaction id
                'shipToDifferentAddress' => 'required',
                'ordPayProvider' => 'required', //1 = Card , 4 = Email
                //'ordShipCarrier' => 'required', //(If Ship collect) Courier Account and billing address
            ];
            if($post['shipToDifferentAddress'] == 1){
                $requiredFields['ordShipCompanyName'] = 'required';
                $requiredFields['ordShipName'] = 'required';
                $requiredFields['ordShipAddress'] = 'required';
                $requiredFields['ordShipCity'] = 'required';
                $requiredFields['ordShipCountry'] = 'required';
                $requiredFields['ordShipState'] = 'required';
                $requiredFields['ordShipZip'] = 'required';
                $requiredFields['ordShipPhone'] = 'required';
//                $requiredFields['ordShipBillingZip'] = 'required';
            }
            //ordAddInfo
            //rememberMe
            $response = $obj->fieldValidation($post, $requiredFields);
            if ($response['status'] == 200) {
                $model = new Order();
                $response = $model->checkout($post,$tIsGuest);
            }
        }else{
            //guest param is required
            $response = ['status' => false, 'message' => 'tIsGuest key is required.'];
        }
    }
}
_response($response);
