<?php
/**
 * @SWG\Post(path="/custom_quotation_request",
 *     summary="Custom quotation request",
 *     consumes={"application/x-www-form-urlencoded"},
 *     @SWG\Parameter(
 *         description="First Name",
 *         in="formData",
 *         name="vFirstName",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Test",
 *     ),
 *     @SWG\Parameter(
 *         description="Last name",
 *         in="formData",
 *         name="vLastName",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="User",
 *     ),
 *     @SWG\Parameter(
 *         description="Email address",
 *         in="formData",
 *         name="vEmail",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="demo.spaceo@gmail.com", 
 *     ),
 *     @SWG\Parameter(
 *         description="Street address",
 *         in="formData",
 *         name="vStreetAddress",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Mansi circle",
 *     ),
 *     @SWG\Parameter(
 *         description="City",
 *         in="formData",
 *         name="vCity",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Ahmedabad",
 *     ),
 *     @SWG\Parameter(
 *         description="State",
 *         in="formData",
 *         name="vState",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Gujarat",
 *     ),
 *     @SWG\Parameter(
 *         description="Country",
 *         in="formData",
 *         name="vCountry",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="India",
 *     ),
 *     @SWG\Parameter(
 *         description="Zip Code",
 *         in="formData",
 *         name="vZipCode",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="123456",
 *     ),
 *     @SWG\Parameter(
 *         description="Custom made",
 *         in="formData",
 *         name="vCustomMade",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="VCI Paper-Ferrous",
 *     ),
 *     @SWG\Parameter(
 *         description="Dimentions",
 *         in="formData",
 *         name="vDimentions",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="22",
 *     ),
 *     @SWG\Parameter(
 *         description="Purchase quentity",
 *         in="formData",
 *         name="vPurchaseQuantity",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="250",
 *     ),
 *     @SWG\Parameter(
 *         description="Purchase frequency",
 *         in="formData",
 *         name="vPurchaseFrequency",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Weekly",
 *     ),
 *     @SWG\Parameter(
 *         description="Telephone",
 *         in="formData",
 *         name="vTelephone",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="9898787898",
 *     ),
 *     @SWG\Parameter(
 *         description="Other state",
 *         in="formData",
 *         name="vOtherState",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="Gujarat",
 *     ),
 *     @SWG\Parameter(
 *         description="Other country",
 *         in="formData",
 *         name="vOtherCountry",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="India",
 *     ),
 *     @SWG\Parameter(
 *         description="Address 2",
 *         in="formData",
 *         name="vAddress2",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="Mansi circle",
 *     ),
 *     @SWG\Parameter(
 *         description="Company name",
 *         in="formData",
 *         name="vCompanyName",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="Test company",
 *     ),
 *     @SWG\Parameter(
 *         description="Thickness",
 *         in="formData",
 *         name="vThickness",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="Thichness",
 *     ),
 *     @SWG\Parameter(
 *         description="Fax",
 *         in="formData",
 *         name="vFax",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="8545856958",
 *     ),
 *     @SWG\Parameter(
 *         description="Message",
 *         in="formData",
 *         name="txMessage",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="Hello world",
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Custom quotation request",
 *         @SWG\Schema(
 *                ref="#/definitions/CustomQuotationFinalResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                           "message": "Custom quotation request sent successfully.",
 *                   }
 *           },
 *     ),
 *   @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ),     
 *         examples={
 *                   "application/json": {
 *                           "message": "clEmail is invalid email."
 *                       }
 *                   },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = $_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post);
    if ($response['status'] == 200) {
        //Validation rules
        $requiredFields = [
            'vFirstName' => 'required',
            'vLastName' => 'required',
            'vEmail' => 'required|email',
            'vStreetAddress' => 'required',
            'vCity' => 'required',
            'vState' => 'required',
            'vCountry' => 'required',
            'vZipCode' => 'required',
            'vCustomMade' => 'required',
            'vDimentions' => 'required',
            'vPurchaseQuantity' => 'required',
            'vPurchaseFrequency' => 'required',
            'vTelephone' => 'required',
            
        ];
        $response = $obj->fieldValidation($post, $requiredFields);
        if ($response['status'] == 200) {
            $model = new Product();
            $response = $model->customQuotationRequest($post);
        }
    }
}
_response($response);
