<?php
/**
 * @SWG\Post(path="/forgotpassword",
 *     summary="Forgot password",
 *     consumes={"application/x-www-form-urlencoded"},
 *     @SWG\Parameter(
 *         description="Email address",
 *         in="formData",
 *         name="clEmail",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="suraj.spaceo@gmail.com",
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Forgot password response",
 *         @SWG\Schema(
 *                ref="#/definitions/ForgotPasswordFinalResponse"
 *              ),
 *         examples={
 *                   "application/json":{
 *                       "message": "Pasword reset mail sent to your email address, Please check your mail inbox."
 *                   } 
 *           },
 *     ),
 *   @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ),       
 *         examples={
 *                   "application/json": {
 *                           "message": "Email address not exist."
 *                       }
 *          },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = $_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post);
    if ($response['status'] == 200) {
        //Validation rules
        $requiredFields = [
            'clEmail' => 'required|email'
        ];
        $response = $obj->fieldValidation($post, $requiredFields);
        if ($response['status'] == 200) {
            $model = new Customerlogin();
            $response = $model->forgotpassword($post);
        }
    }
}
_response($response);
