<?php

/**
 * @SWG\Post(path="/get_guest_cart_shippingcharge",
 *     summary="Get guest cart shipping charge",
 *     @SWG\Parameter(
 *         description="Cart json",
 *         in="formData",
 *         name="cart_json",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="{{'cartProdID':'Mil-PRF-16173','cartQuantity':'6','coOptID':'0'},{'cartProdID':'silvsav3x5','cartQuantity':'2','coOptID':'0'},{'cartProdID':'VCI-1_Powder','cartQuantity':'2','coOptID':'50'}}",
 *     ),
 *     @SWG\Parameter(
 *         description="Country id",
 *         in="formData",
 *         name="countryID",
 *         required=false,
 *         type="integer",
 *         format="integer",
 *         default="1",
 *     ),
 *     @SWG\Parameter(
 *         description="Zip code",
 *         in="formData",
 *         name="zipCode",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="90001",
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Guest cart shipping charge",
 *         @SWG\Schema(
 *                ref="#/definitions/getGuestCartShippingchargeFinalResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                       {
 *                          "message": "Cart list",
 *                          "data": {
 *                              "dSubTotal": 385.9,
 *                              "dShippingHandlingCharge": 37.870000000000005,
 *                              "dGrandTotal": 423.77
 *                          }
 *                      }
 *                   }
 *          },
 *     ),
 *    @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ), 
 *         examples={
 *                   "application/json": {
 *                         "message": "Guest cart shipping charge",
 *                         "data": {}
 *                   }
 *         },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = $_POST; //$_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post, false);
    if ($response['status'] == 200) {
        //Validation rules
        $requiredFields = [
            'cart_json' => 'required',
        ];
        $response = $obj->fieldValidation($post, $requiredFields);
        if ($response['status'] == 200) {
            $model = new Cart();
            $response = $model->getGuestCartShippingCharge($post);
        }
    }
}
_response($response);
