<?php

/**
 * @SWG\Get(path="/go_shopping",
 *     summary="Go shopping list",
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Go shopping list response",
 *         @SWG\Schema(
 *                ref="#/definitions/GoShoppingFinalResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                       "message": "Go shopping list",
 *                       "data": {
 *                           "go_shopping_list": {
 *                               {
 *                                   "sectionID": 22,
 *                                   "sectionName": "Specials",
 *                                   "isSubCategory": 0,
 *                                   "list": {
 *                                       {
 *                                           "id": "VCI-4x1000",
 *                                           "name": "VCI Tubing 4 Inch",
 *                                           "image": "http://172.16.17.149/project/kpr/code/mobi/i/prodimages/vci-tubing.jpg",
 *                                           "isSubCategory": 0
 *                                       }
 *                                   }
 *                               }
 *                           },
 *                           "advert": {
 *                               {
 *                                   "url": "http://172.16.17.149/project/kpr/code/mobi/i/proddetail.php?prod=nr3100A",
 *                                   "image": "http://172.16.17.149/project/kpr/code/mobi/i/prodimages/Nox-Rust-Aerosols.jpg"
 *                               }
 *                           }
 *                       }
 *                 }
 *          }
 *     ),
 *    @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ), 
 *         examples={
 *                   "application/json": {
 *                         "message": "Category list.",
 *                         "data": {}
 *                   }
 *         },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = []; //$_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('GET');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post, false);
    if ($response['status'] == 200) {
        $model = new Section();
        $response = $model->go_shopping();
    }
}
_response($response);
