<?php

/**
 * @SWG\Swagger(
 *     schemes={"http","https"},
 *     host=SWAGGER_HOST,
 *     basePath=SWAGGER_BASE_PATH,
 *     produces={"application/json","application/xml"},
 *     consumes={"application/x-www-form-urlencoded"},
 *     @SWG\Info(
 *         version="1.0.0",
 *         title=SITENAME,
 *         termsOfService="",
 *         @SWG\Contact(
 *             email="contact@mysite.com"
 *         ),
 *     ),
 * )
 * @SWG\Post(path="/login",
 *     summary="User login",
 *     consumes={"application/x-www-form-urlencoded"},
 *     @SWG\Parameter(
 *         description="Email address",
 *         in="formData",
 *         name="clEmail",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="suraj.spaceo@gmail.com",
 *     ),
 *     @SWG\Parameter(
 *         description="Password",
 *         in="formData",
 *         name="clPW",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="123456",
 *     ),
 *     @SWG\Parameter(
 *         description="Lastname of user",
 *         in="formData",
 *         name="vLastName",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="demo", 
 *     ),
 *     @SWG\Parameter(
 *         description="iPhone / Android device token",
 *         in="formData",
 *         name="txDeviceToken",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="",
 *     ),
 *     @SWG\Parameter(
 *         description="1 = ANDROID , 2 = IOS",
 *         in="formData",
 *         name="tDeviceOs",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="1",
 *     ),
  *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "User login response",
 *         @SWG\Schema(
 *                ref="#/definitions/LoginFinalResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                          
 *                          "message": "Login success.",
 *                          "data": {
 *                          "clID": "586",
 *                          "clUserName": "Suraj patel",
 *                          "clEmail": "suraj.spaceo@gmail.com",
 *                          
 *                   }
 *               }
 *         },
 *     ),
 *   @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ),      
 *         examples={
 *                   "application/json": {
 *                           "message": "Wrong email or password."
 *                       }
 *                  },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = $_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post);
    if ($response['status'] == 200) {
        //Validation rules
        $requiredFields = [
            'clPW' => 'required',
            'clEmail' => 'required|email',
            'txDeviceToken' => 'required',
            'tDeviceOs' => 'required'
        ];
        $response = $obj->fieldValidation($post, $requiredFields);
        if ($response['status'] == 200) {
            $model = new Customerlogin();
            $response = $model->login($post);
        }
    }
}
_response($response);
