<?php

/**
 * @SWG\Get(path="/notification_list",
 *     summary="Notification list",
 *     @SWG\Parameter(
 *         name="clID",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default="586",
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Notification list response",
 *         @SWG\Schema(
 *                ref="#/definitions/NotificationListFinalResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                   "message": "Notification list",
 *                   "data": {
 *                       "totalRecord": 5,
 *                       "totalPage": 1,
 *                       "nextPage": 0,
 *                       "data": {
 *                           {
 *                               "iNotificationId": 5,
 *                               "tNotificationType": 1,
 *                               "created_at": "13 minutes ago",
 *                               "tRead": 0,
 *                               "txParameters": {
 *                                   "ordID": 5048
 *                               },
 *                               "vTitle": "Product purchase",
 *                               "vText": "Your order is placed successfully with order id 5048"
 *                           },
 *                           {
 *                               "iNotificationId": 4,
 *                               "tNotificationType": 1,
 *                               "created_at": "13 minutes ago",
 *                               "tRead": 0,
 *                               "txParameters": {
 *                                   "ordID": 5047
 *                               },
 *                               "vTitle": "Product purchase",
 *                               "vText": "Your order is placed successfully with order id 5047"
 *                           }
 *                       }
 *                   }
 *               }
 *          },
 *     ),
 *    @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ), 
 *         examples={
 *                   "application/json": {
 *                         "message": "Notification list list.",
 *                         "data": {}
 *                   }
 *         },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = []; //$_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('GET');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post, false);
    if ($response['status'] == 200) {
        //User Authentication
        $response = Authentication::auth_user();
        if ($response['status'] == 200) {
            $model = new Notification();
            $response = $model->notificationList();
        }
    }
}
_response($response);
