<?php

/**
 * @SWG\Post(path="/page",
 *     summary="Static pages",
 *     consumes={"application/x-www-form-urlencoded"},
 *     @SWG\Parameter(
 *         description="Page slug",
 *         in="formData",
 *         name="vSlug",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="about_us",
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "User collection response",
 *         @SWG\Schema(
 *                ref="#/definitions/PageFinalResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                          
 *                          "message": "Login success.",
 *                          "data": {
 *                          "clID": "586",
 *                          "clUserName": "Suraj patel",
 *                          "clEmail": "suraj.spaceo@gmail.com",
 *                          
 *                   }
 *               }
 *         },
 *     ),
 *   @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ),         
 *         examples={
 *                   "application/json": {
 *                           "message": "Wrong email or password."
 *                       }
 *                  },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = $_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post);
    if ($response['status'] == 200) {
        //Validation rules
        $requiredFields = [
            'vSlug' => 'required'
        ];
        $response = $obj->fieldValidation($post, $requiredFields);
        if ($response['status'] == 200) {
            $model = new Page();
                $response = $model->get_page_content($post);
        }
    }
}
_response($response);
