<?php
/**
 * @SWG\Get(path="/product_technical_sheet",
 *     summary="Product technical sheet",
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Product technical sheet response",
 *         @SWG\Schema(
 *                ref="#/definitions/ProductTechnicalSheetFinalResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                      {
 *                           "message": "Product technical sheet",
 *                           "data": {
 *                               {
 *                                   "name": "1101.pdf",
 *                                   "date": "03-07-2018",
 *                                   "description": "Nox-Rust 1101 VCI-10 Oil Mil-P46002 Oil additive concentrated version\n",
 *                                   "size": 267881,
 *                                   "type": "pdf",
 *                                   "link": "http://172.16.17.149/project/kpr/code/pdf/1101.pdf"
 *                               },
 *                               {
 *                                   "name": "1200.pdf",
 *                                   "date": "03-07-2018",
 *                                   "description": "Nox-Rust 1200 corrosion protection water additive for hydrotesting and short to medium corrosion control.\n",
 *                                   "size": 254218,
 *                                   "type": "pdf",
 *                                   "link": "http://172.16.17.149/project/kpr/code/pdf/1200.pdf"
 *                               }
 *                           }
 *                      }
 *                 }
 *           },
 *     ),
 *    @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                         "message": "Product technical sheet.",
 *                         "data": {}
 *                   }
 *         },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = []; //$_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('GET');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post, false);
    if ($response['status'] == 200) {
        $model = new Section();
        $response = $model->productTechnicalSheet();
    }
}
_response($response);