<?php

/**
 * @SWG\Post(path="/search_product",
 *     summary="Search product list",
 *     consumes={"application/x-www-form-urlencoded"},
 *     @SWG\Parameter(
 *         description="Page no",
 *         in="formData",
 *         name="pageno",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="",
 *     ),
 *     @SWG\Parameter(
 *         description="Category id (section id)",
 *         in="formData",
 *         name="sectionID",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="",
 *     ),
 *     @SWG\Parameter(
 *         description="Search text",
 *         in="formData",
 *         name="search_text",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="",
 *     ),
 *     @SWG\Parameter(
 *         description="Max price",
 *         in="formData",
 *         name="maxPrice",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="",
 *     ),
 *     @SWG\Parameter(
 *         description="Search type",
 *         in="formData",
 *         name="searchType",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="",
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Search product",
 *         @SWG\Schema(
 *                ref="#/definitions/SearchProductFinalResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                           "message": "Search product list",
 *                           "totalRecord": 9,
 *                           "totalPage": 1,
 *                           "nextPage": "",
 *                           "data": {
 *                               {
 *                                   "relevanceorder": 0,
 *                                   "pID": "13500",
 *                                   "pName": "Heat Shrink Pallet Size Bags 44x44x70",
 *                                   "pPrice": 147.03,
 *                                   "pOrder": 0,
 *                                   "pDescription": "",
 *                                   "pDisplay": 1,
 *                                   "image": ""
 *                               },
 *                               {
 *                                   "relevanceorder": 0,
 *                                   "pID": "13510",
 *                                   "pName": "Heat Shrink Pallet Size Bags 48x46x72",
 *                                   "pPrice": 161.55,
 *                                   "pOrder": 0,
 *                                   "pDescription": "",
 *                                   "pDisplay": 1,
 *                                   "image": ""
 *                               }
 *                           }
 *                  }
 *          },
 *     ),
 *    @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ),   
 *         examples={
 *                   "application/json": {
 *                   "message": "Search product list",
 *                   "totalRecord": 0,
 *                   "totalPage": 0,
 *                   "nextPage": "",
 *                   "data": {}
 *               }
 *         },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */

$response = [];
$post = $_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post);
    if ($response['status'] == 200) {
        $model = new Product();
        $response = $model->search_product($post);
    }
}
_response($response);