<?php

/**
 * @SWG\Post(path="/sub_category_list",
 *     summary="Sub category list",
 *     consumes={"application/x-www-form-urlencoded"},
 *     @SWG\Parameter(
 *         description="Category id (root section id)",
 *         in="formData",
 *         name="sectionID",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="15",
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "User collection response",
 *         @SWG\Schema(
 *                ref="#/definitions/SubCategoryListFinalResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                         "message": "Sub category list.",
 *                         "data": {
 *                              {
 *                                  "sectionID": 16,
 *                                  "sectionName": "VCI Emitters Adhesive Backed",
 *                                  "sectionImage": "//www.static.corrosionvci.com/prodimages/mde-vci-emitter.jpg",
 *                                  "isSubCategory": 0
 *                              },
 *                              {
 *                                  "sectionID": 17,
 *                                  "sectionName": "VCI Foam Inserts",
 *                                  "sectionImage": "//www.static.corrosionvci.com/prodimages/p-150.jpg",
 *                                  "isSubCategory": 0
 *                              },
 *                           }
 *                  }
 *          },
 *     ),
 *    @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ), 
 *         examples={
 *                   "application/json": {
 *                         "message": "Sub category list.",
 *                   }
 *         },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = $_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post);
    if ($response['status'] == 200) {
        //Validation rules
        $requiredFields = [
            'sectionID' => 'required|integer',
        ];
        $response = $obj->fieldValidation($post, $requiredFields);
        if ($response['status'] == 200) {
            $model = new Section();
            $response = $model->sub_category_list($post);
        }
    }
}
_response($response);
