<?php

/**
 * @SWG\Post(path="/update_cart_qty",
 *     summary="Update cart quentity",
 *     consumes={"application/x-www-form-urlencoded"},
 *     @SWG\Parameter(
 *         description="Cart id",
 *         in="formData",
 *         name="cartID",
 *         required=true,
 *         type="int64",
 *         format="integer",
 *         default="2290",
 *     ),
 *     @SWG\Parameter(
 *         description="Cart quantity",
 *         in="formData",
 *         name="cartQuantity",
 *         required=true,
 *         type="int",
 *         format="integer",
 *         default="2",
 *     ),
 *     @SWG\Parameter(
 *         name="clID",
 *         in="header",
 *         required=false,
 *         type="string",
 *         default="586",
 *     ),
 *     @SWG\Parameter(
 *         description="Is guest (0 = Login user, 1 = Guest)",
 *         name="tIsGuest",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default="0",
 *     ),
 *     @SWG\Parameter(
 *         name="cartSessionID",
 *         in="header",
 *         required=false,
 *         type="string",
 *         default="",
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Update cart quantity",
 *         @SWG\Schema(
 *                ref="#/definitions/UpdateCartQtyFinalResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                       "message": "Quantity updated."
 *                   }
 *          },
 *     ),
 *    @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ), 
 *         examples={
 *                   "application/json": {
 *                         "message": "Quantity updated.",
 *                         "data": {}
 *                   }
 *         },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = $_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post);
    if ($response['status'] == 200) {
        
        if(isset($_SERVER['HTTP_TISGUEST']) && trim($_SERVER['HTTP_TISGUEST']) != ""){
            $tIsGuest = trim($_SERVER['HTTP_TISGUEST']);
            if($tIsGuest == 0 || $tIsGuest == ""){
                //User Authentication
                $response = Authentication::auth_user();
                if ($response['status'] != 200) {
                    _response($response);
                    return;
                }
            }
            //Validation rules
            $requiredFields = [
                'cartQuantity' => 'required',
                'cartID' => 'required',
            ];
            $response = $obj->fieldValidation($post, $requiredFields);
            if ($response['status'] == 200) {
                $model = new Cart();
                $response = $model->updateCartQty($post,$tIsGuest);
            }
        }else{
            //guest param is required
            $response = ['status' => false, 'message' => 'tIsGuest key is required.'];
        }
    }
}
_response($response);
