<?php

/**
 * @SWG\Post(path="/vci_selection_help",
 *     summary="Vci selection help",
 *     @SWG\Parameter(
 *         name="vName",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="abc",
 *     ),
 *     @SWG\Parameter(
 *         name="vEmail",
 *         in="formData",
 *         required=true,
 *         format="string",
 *         default="abc@test.com",
 *     ),
 *     @SWG\Parameter(
 *         name="vCompanyName",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="xyz company",
 *     ),
 *     @SWG\Parameter(
 *         name="txStreetAddress",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="one street",
 *     ),
 *     @SWG\Parameter(
 *         name="vCity",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Ahmedabad",
 *     ),
 *     @SWG\Parameter(
 *         name="vState",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Gujarat",
 *     ),
 *     @SWG\Parameter(
 *         name="vCountry",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="India",
 *     ),
 *     @SWG\Parameter(
 *         name="vZipCode",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="90001",
 *     ),
 *     @SWG\Parameter(
 *         name="vTypeOfProductWantToProtect",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="one type",
 *     ),
 *     @SWG\Parameter(
 *         name="vTermOfProtection",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="10 days",
 *     ),
 *     @SWG\Parameter(
 *         name="vIsThisForDomastic",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Domestic",
 *     ),
 *     @SWG\Parameter(
 *         name="txCurrentlyUsingVciProduct",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="four",
 *     ),
 *     @SWG\Parameter(
 *         name="vChecmicalOilPresent",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Yes",
 *     ),
 *     @SWG\Parameter(
 *         name="vIsSurfaceDryAndClean",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Clean",
 *     ),
 *     @SWG\Parameter(
 *         name="vSpecialTreatmentPresent",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="Not present",
 *     ),
 *     @SWG\Parameter(
 *         name="txSizeAndWeightOfProduct",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="10 kg",
 *     ),
 *     @SWG\Parameter(
 *         name="vMethodOfCorrosionProtection",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="VCI poly bags",
 *     ),
 *     @SWG\Parameter(
 *         name="vPartsPerPackage",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="200",
 *     ),
 *     @SWG\Parameter(
 *         name="vTelephone",
 *         in="formData",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="9656585696",
 *     ),
 *     @SWG\Parameter(
 *         name="txAddress2",
 *         in="formData",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="A street",
 *     ),
 *     @SWG\Parameter(
 *         name="vOtherState",
 *         in="formData",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="Unknown state",
 *     ),
 *     @SWG\Parameter(
 *         name="vOtherCountry",
 *         in="formData",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="Unknown country",
 *     ),
 *     @SWG\Parameter(
 *         name="txUnsatisfactoryCurrentMethod",
 *         in="formData",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="no method",
 *     ),
 *     @SWG\Parameter(
 *         name="vSubject",
 *         in="formData",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="vci selection help",
 *     ),
 *     @SWG\Parameter(
 *         name="txAdditionalInformation",
 *         in="formData",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="hello",
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Vci selection help response",
 *         @SWG\Schema(
 *                ref="#/definitions/VciSelectionFinalResponse"
 *         ),
 *         examples={
 *                   "application/json": {
 *                           {
 *                               "message": "Vci selection help message sent successfully."
 *                           }
 *                  }
 *          },
 *     ),
 *    @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *         ),
 *         examples={
 *                   "application/json": {
 *                         "message": "No record.",
 *                         "data": {}
 *                   }
 *         },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = $_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post, false);
    if ($response['status'] == 200) {
        //User Authentication
        //Validation rules
        $requiredFields = [
            'vName' => 'required',
            'vEmail' => 'required|email',
            'vCompanyName' => 'required',
            'txStreetAddress' => 'required',
            'vCity' => 'required',
            'vState' => 'required',
            'vCountry' => 'required',
            'vZipCode' => 'required',
            'vTypeOfProductWantToProtect' => 'required',
            'vTermOfProtection' => 'required',
            'vIsThisForDomastic' => 'required',
            'txCurrentlyUsingVciProduct' => 'required',
            'vChecmicalOilPresent' => 'required',
            'vIsSurfaceDryAndClean' => 'required',
            'vSpecialTreatmentPresent' => 'required',
            'txSizeAndWeightOfProduct' => 'required',
            'vMethodOfCorrosionProtection' => 'required',
            'vPartsPerPackage' => 'required',
            'vTelephone' => 'required',
        ];
        $response = $obj->fieldValidation($post, $requiredFields);
        if ($response['status'] == 200) {
            $model = new Product();
            $response = $model->vciSelectionHelp($post);
        }
    }
}
_response($response);
