<?php

use Illuminate\Database\Eloquent\Model as Eloquent;
use Illuminate\Database\Capsule\Manager as DB;

class Page extends Eloquent {

    protected $table = 'pages';
    protected $primaryKey = 'iPageId';
    public $timestamps = false;

    public function get_page_content($post) {
        try {
            $page = Page::select('iPageId', 'vTitle', 'tDescription')->where(['vSlug' => $post['vSlug']])->first();

            if (!empty($page)) {
                $response = ['status' => true, 'message' => 'operation_success', 'data' => $page];
            } else {
                $response = ['status' => false, 'message' => 'invalid_page_slug'];
            }
        } catch (Exception $ex) {
            return ['status' => false, 'message' => (THROW_EXCEPTION) ? $ex->getMessage() : 'something_wrong'];
        }
        return $response;
    }

}
