<?php

class vrNodeList {

    var $length;
    var $childNodes;
    var $nodeName;
    var $nodeValue;
    var $attributes;

    function createNodeList($xmlStr) {
        $xLen = strlen($xmlStr);
        for ($i = 0; $i < $xLen; $i++) {
            if (substr($xmlStr, $i, 1) == '<' && substr($xmlStr, $i + 1, 1) != '/' && substr($xmlStr, $i + 1, 1) != '?') { // Got a tag
                $j = strpos($xmlStr, '>', $i);
                $l = strpos($xmlStr, ' ', $i);
                if (is_integer($l) && $l < $j) {
                    $this->nodeName[$this->length] = substr($xmlStr, $i + 1, $l - ($i + 1));
                    $this->attributes[$this->length] = substr($xmlStr, $l + 1, ($j - $l) - 1);
                } else
                    $this->nodeName[$this->length] = substr($xmlStr, $i + 1, $j - ($i + 1));
                $k = $i + 1;
                $nodeNameLen = strlen($this->nodeName[$this->length]);
                if (substr($xmlStr, $j - 1, 1) == '/') {
                    $this->nodeValue[$this->length] = null;
                } else {
                    $currLev = 0;
                    while ($k < $xLen && $currLev >= 0) {
                        if (substr($xmlStr, $k, 2) == '</') {
                            if ($currLev == 0 && substr($xmlStr, $k + 2, $nodeNameLen) == $this->nodeName[$this->length])
                                break;
                            $currLev--;
                        }elseif (substr($xmlStr, $k, 1) == '<')
                            $currLev++;
                        elseif (substr($xmlStr, $k, 2) == '/>')
                            $currLev--;
                        $k++;
                    }
                    $this->nodeValue[$this->length] = substr($xmlStr, $j + 1, $k - ($j + 1));
                }
                $this->childNodes[$this->length] = new vrNodeList($this->nodeValue[$this->length]);
                $this->length++;
                $i = $k;
            }
        }
    }

    function __construct($xmlStr) {
        $this->length = 0;
        $this->childNodes = [];
        $this->createNodeList($xmlStr);
    }

    function getValueByTagName($tagname) {
        for ($i = 0; $i < $this->length; $i++) {
            if ($this->nodeName[$i] == $tagname) {
                return($this->nodeValue[$i]);
            } else {
                if (count($this->childNodes) > 0) {
                    if (($retval = $this->childNodes[$i]->getValueByTagName($tagname)) != null)
                        return($retval);
                }
            }
        }
        return(null);
    }

    function getAttributeByTagName($tagname, $attrib) {
        for ($i = 0; $i < $this->length; $i++) {
            if ($this->nodeName[$i] == $tagname) {
                return(getattributes($this->attributes[$i], $attrib));
            } else {
                if (count($this->childNodes) > 0) {
                    if (($retval = $this->childNodes[$i]->getAttributeByTagName($tagname, $attrib)) != null)
                        return($retval);
                }
            }
        }
        return(null);
    }

}
