<?php

/**
 * @SWG\Get(path="/custom_quote_options",
 *     summary="Custom quote options list",
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Custom quote options list response",
 *         examples={
 *                   "application/json": {
 *                       "message": "Custom quote options list",
 *                       "data": {
 *                           "state_list": {
 *                               {
 *                                   "vName": "Alabama"
 *                               },
 *                               {
 *                                   "vName": "Alaska"
 *                               }
 *                           },
 *                           "custom_made_list": {
 *                               {
 *                                   "vName": "VCI Paper-Ferrous"
 *                               },
 *                               {
 *                                   "vName": "VCI Paper-Multi-metal"
 *                               }
 *                           },
 *                           "thickness_list": {
 *                               {
 *                                   "vName": "2 Mil"
 *                               },
 *                               {
 *                                   "vName": "3 Mil"
 *                               }
 *                           },
 *                           "purchase_qty_list": {
 *                               {
 *                                   "vName": "250"
 *                               },
 *                               {
 *                                   "vName": "500"
 *                               }
 *                           },
 *                           "purchase_frequency_list": {
 *                               {
 *                                   "vName": "Weekly"
 *                               },
 *                               {
 *                                   "vName": "Monthly"
 *                               }
 *                           }
 *                       }
 *                   }
 *          },
 *     ),
 *    @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         examples={
 *                   "application/json": {
 *                         "message": "Custom quote options list.",
 *                         "data": {}
 *                   }
 *         },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = []; //$_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('GET');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post, false);
    if ($response['status'] == 200) {
        $model = new Customerlogin();
        $response = $model->customQuoteOptions();
    }
}
_response($response);
