<?php

/**
 * @SWG\Get(path="/go_shopping",
 *     summary="Go shopping list",
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "User collection response",
 *         examples={
 *                   "application/json": {
 *                         "message": "Category list.",
 *                         "data": {
 *                                   {
 *                                      "sectionID": "22",
 *                                      "sectionName": "Specials"
 *                                   },
 *                                   {
 *                                      "sectionID": "5",
 *                                      "sectionName": "VCI Paper Industrial Packaging"
 *                                   }
 *                           }
 *                  }
 *          },
 *     ),
 *    @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         examples={
 *                   "application/json": {
 *                         "message": "Category list.",
 *                         "data": {}
 *                   }
 *         },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = []; //$_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('GET');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post, false);
    if ($response['status'] == 200) {
        $model = new Section();
        $response = $model->go_shopping();
    }
}
_response($response);
