<?php

/**
 * @SWG\Post(path="/product_list",
 *     summary="Product list",
 *     consumes={"application/x-www-form-urlencoded"},
 *     @SWG\Parameter(
 *         description="Page no",
 *         in="formData",
 *         name="pageno",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="1",
 *     ),
 *     @SWG\Parameter(
 *         description="Category id (section id)",
 *         in="formData",
 *         name="sectionID",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="22",
 *     ),
 *     @SWG\Parameter(
 *         description="Search text",
 *         in="formData",
 *         name="search_text",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="VCI",
 *     ),
 *     @SWG\Parameter(
 *         description="Max price",
 *         in="formData",
 *         name="maxPrice",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="100",
 *     ),
 *     @SWG\Parameter(
 *         description="Search type",
 *         in="formData",
 *         name="searchType",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="0",
 *     ),
*     @SWG\Parameter(
 *         description="In category",
 *         in="formData",
 *         name="inCategory",
 *         required=false,
 *         type="string",
 *         format="string",
 *         default="0",
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "Product list",
 *         examples={
 *                   "application/json": {
 *                           "message": "Product list",
 *                           "totalRecord": 9,
 *                           "totalPage": 1,
 *                           "nextPage": "",
 *                           "data": {
 *                               {
 *                                   "pID": "VCI-4x1000",
 *                                   "pName": "VCI Tubing 4 Inch",
 *                                   "pPrice": 70,
 *                                   "pDescription": "description in html form",
 *                                   "image": "//www.static.corrosionvci.com/prodimages/vci-tubing.jpg"
 *                               },
 *                               {
 *                                   "pID": "VCI-sheeting-36x36",
 *                                   "pName": "VCI CF18X36  Sheets Perf On Roll",
 *                                   "pPrice": 104.15,
 *                                   "pDescription": "description in html form",
 *                                   "image": "//www.static.corrosionvci.com/prodimages/vci-poly-sheets.jpg"
 *                               }
 *                           }
 *                  }
 *          },
 *     ),
 *    @SWG\Response(
 *         response = 400,
 *         description = "Confilct",
 *         examples={
 *                   "application/json": {
 *                   "message": "Product list",
 *                   "totalRecord": 0,
 *                   "totalPage": 0,
 *                   "nextPage": "",
 *                   "data": {}
 *               }
 *         },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = $_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post);
    if ($response['status'] == 200) {
        //Validation rules
//        $requiredFields = [
//            'sectionID' => 'required|integer',
//        ];
//        $response = $obj->fieldValidation($post, $requiredFields);
//        if ($response['status'] == 200) {
            $model = new Product();
            $response = $model->product_list($post);
        //}
    }
}
_response($response);
