<?php
/**
 * @SWG\Post(path="/signup",
 *     summary="User signup",
 *     consumes={"application/x-www-form-urlencoded"},
 *     @SWG\Parameter(
 *         description="Email address",
 *         in="formData",
 *         name="clEmail",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="demo.spaceo@gmail.com",
 *     ),
 *     @SWG\Parameter(
 *         description="Password",
 *         in="formData",
 *         name="clPW",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="123456",
 *     ),
 *     @SWG\Parameter(
 *         description="Lastname of user",
 *         in="formData",
 *         name="vLastName",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="demo", 
 *     ),
 *     @SWG\Parameter(
 *         description="iPhone / Android device token",
 *         in="formData",
 *         name="txDeviceToken",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="",
 *     ),
 *     @SWG\Parameter(
 *         description="1 = ANDROID , 2 = IOS",
 *         in="formData",
 *         name="tDeviceOs",
 *         required=true,
 *         type="string",
 *         format="string",
 *         default="1",
 *     ),
 *     @SWG\Parameter(
 *         name="nonce",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=NONCE,
 *     ),
 *      @SWG\Parameter(
 *         name="timestamp",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TIMESTAMP,
 *     ),
 *      @SWG\Parameter(
 *         name="token",
 *         in="header",
 *         required=true,
 *         type="string",
 *         default=TOKEN,
 *     ),
 *     @SWG\Response(
 *         response = 200,
 *         description = "User signup response",
 *         @SWG\Schema(
 *                ref="#/definitions/SignupFinalResponse"
 *              ),
 *         examples={
 *                   "application/json": {
 *                           "message": "Signup success.",
 *                           "data": {
 *                           "clID": "589",
 *                           "clUserName": "Suraj patel",
 *                           "clEmail": "suraj.spaceo10@gmail.com"
 *                       }
 *                   }
 *           },
 *     ),
 *   @SWG\Response(
 *         response = 400,
 *         description = "Confilct",   
 *         @SWG\Schema(
 *                ref="#/definitions/ErrorResponse"
 *              ),        
 *         examples={
 *                   "application/json": {
 *                           "message": "clEmail is invalid email."
 *                       }
 *                   },
 *     ),
 *     @SWG\Response(
 *         response="404",
 *         description="page not found"
 *     ),
 * )
 */
$response = [];
$post = $_POST;

$obj = new Common();
//Content type validation
$response = $obj->checkContentType('POST');
if ($response['status'] == 200) {
    //Nonce-Token & request validation
    $response = $obj->apiRequestCheck($post);
    if ($response['status'] == 200) {
        //Validation rules
        $requiredFields = [
            'clUserName' => 'required',
            'clPW' => 'required',
            'clEmail' => 'required|email',
            'txDeviceToken' => 'required',
            'tDeviceOs' => 'required'
        ];
        $response = $obj->fieldValidation($post, $requiredFields);
        if ($response['status'] == 200) {
            $model = new Customerlogin();
            $response = $model->signup($post);
        }
    }
}
_response($response);
