<?php

use ActiveRecord\ConnectionManager;
use ActiveRecord\Model;

class Section extends Model {

    static $table_name = 'sections';

    public function category_list() {
        $response = [];
        try {
            $sectionList = Section::find('all',[
                        'select' => "sectionID,sectionName",
                        'conditions' => [
                            'topSection' => 0,
                        ],
                        'order' => 'sectionOrder ASC'
            ]);
            
            $result = [];
            if(!empty($sectionList)){
                foreach ($sectionList as $key => $val){
                    $result[] = [
                        'sectionID' => $val->sectionid,
                        'sectionName' => $val->sectionname
                    ];
                }
            }
            
            $response = ['status' => true, 'message' => 'Category list.', 'data' => $result];
            
        } catch (Exception $ex) {
            $response = ['status' => false, 'message' => $ex->getMessage()];
        }
        return $response;
    }

}
